/*
 * Entrance.java
 *
 * Created on 30 juin 2005, 19:46
 */

package projet_these.ig;

import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import java.awt.*;
import projet_these.es.*;

/**
 * A JDialog that aim to guide lost users
 * @author Yann Letrillard
 */
public class Entrance extends javax.swing.JDialog implements ActionListener {
    
    /**
     * Creates new form Entrance
     * @param parent The main frame of TESD
     * @param modal Tels if Entrance have to be always on to and kip focus
     * @param super_frame The main frame of TESD
     */
    public Entrance(java.awt.Frame parent, boolean modal, MainFrame super_frame) {
        super(parent, modal);
        initComponents();
        
        this.super_frame = super_frame;
        
        buttonGroup1.add(jRadioButton1);
        buttonGroup1.add(jRadioButton2);
        jButton1.setActionCommand("Ok");
        jButton2.setActionCommand("Cancel");
        jButton2.addActionListener(this);
        jButton1.addActionListener(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        jLabel1 = new javax.swing.JLabel();
        jRadioButton1 = new javax.swing.JRadioButton();
        jRadioButton2 = new javax.swing.JRadioButton();
        jPanel1 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("ENTRANCE");
        setModal(true);
        setResizable(false);
        jLabel1.setText("What do you plan to do?");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(15, 10, 10, 10);
        getContentPane().add(jLabel1, gridBagConstraints);

        jRadioButton1.setText("Set parameters of a new simulation");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        getContentPane().add(jRadioButton1, gridBagConstraints);

        jRadioButton2.setText("Load registered simulation's parameters");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        getContentPane().add(jRadioButton2, gridBagConstraints);

        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.RIGHT));

        jButton1.setText("OK");
        jPanel1.add(jButton1);

        jButton2.setText("Cancel");
        jPanel1.add(jButton2);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 10, 10);
        getContentPane().add(jPanel1, gridBagConstraints);

        pack();
    }
    // </editor-fold>//GEN-END:initComponents
    
    /**
     * Define what to do when the user clic on ok: close, start a simulation or 
     * look at a graph from a file
     * @param e The action of pressing ok button
     */
    public void actionPerformed(ActionEvent e) {
        if (e.getActionCommand() == "Cancel"){
            dispose();
        }
        
        if (e.getActionCommand() == "Ok"){
            if (jRadioButton1.isSelected()){
                dispose();
                startSimulationSetting();
            } else if (jRadioButton2.isSelected()){
                setIntputFile();
            } 
        }
        
    }
    
    /**
     * Let the user choosing an input file to see its graph
     */
    protected void setIntputFile() {
        
        //The local string contaning the path
        String file = "";
        
        //chooser is the instance of this JFileChooser
        JFileChooser chooser = new JFileChooser();
        
        ExampleFileFilter filter = new ExampleFileFilter();
        
        filter.addExtension("para");
        filter.setDescription("Simulation's parameters file");
        
        chooser.setFileFilter(filter);
        
        //make the file chooser to open in the current directoy of MainFrame
        if(super_frame.getCurrentPath() != null)
            chooser.setCurrentDirectory(new File(super_frame.getCurrentPath()));
        
        //a value (determining if a file is choosen) is returned as retVal
        int return_value = chooser.showDialog(super_frame, null);
        
        if (return_value == chooser.APPROVE_OPTION) {
            //setting of the global path to be portable on different systems
            file = chooser.getSelectedFile().getAbsolutePath();
            super_frame.setCurrentPath(file.substring(0,
                    file.lastIndexOf(System.getProperty("file.separator"))));
            
            String simul_name = file.toString().substring(0, file.indexOf(".para", 0));
            
            this.super_frame.model.nomFic1 = file.toString();
            this.super_frame.model.nomFic2 = simul_name;
            InitIslanModelFromFile.initModel(super_frame.model);
            this.super_frame.setEntries();
            this.super_frame.item3.setEnabled(true);
            this.super_frame.menu.setEnabled(true);
            SimulationForm next_form = new SimulationForm(super_frame, true, super_frame);
            int next_formX = (int)this.getBounds().getCenterX()-(next_form.getWidth()/2);
            int next_formY = (int)this.getBounds().getCenterY()-(next_form.getHeight()/2);
            next_form.setLocation(new Point(next_formX, next_formY));
            this.dispose();
            next_form.setVisible(true);
            OutPutDataFiles.checkExistingOutputFiles(new File(file));
        }
    }
    
    private void startSimulationSetting(){
        
        try {
            if (super_frame.model.modelFile != null)
                super_frame.model.modelFile.delete();
        } catch (SecurityException sec_exc) {
                /*Imprime sur la sortie standard ou sur un stream,
                 l'exception et la trace de l'exception dans la pile*/
            sec_exc.printStackTrace();
        }
        
            /* Creation d'une fenetre interne de saisie en ligne
             des parametres*/
        OnLine on_line = new OnLine(super_frame);
        super_frame.desktop.add(on_line);
        try {
            on_line.setSelected(true);
        } catch (java.beans.PropertyVetoException ve) {
        }
        
        // Desactivation des menus Simulations
        super_frame.menu.setEnabled(false);
        
            /* Desactivation de l'item Run et du menu des
            representations graphiques*/
        super_frame.item3.setEnabled(false);
        
        // Initialisation des compteurs de Simulation
        Simulation.initMeters();
    }
    
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton2;
    // End of variables declaration//GEN-END:variables
    private MainFrame super_frame;
}
