/*
 * MolecularRates.java
 *
 *
 */

package projet_these.ig;

import java.awt.event.*;
import javax.swing.event.*;

/**
 * The JDialog from which the user can set the molecular rates of TEs during a 
 * simulation
 * @author Grgory Deceliere
 */
public class MolecularRates
    extends javax.swing.JDialog
{

  private javax.swing.JButton jButton1;
  private javax.swing.JButton jButton2;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JLabel jLabel2;
  private javax.swing.JLabel jLabel3;
  private javax.swing.JLabel jLabel4;
  private javax.swing.JSlider jSlider1;
  private javax.swing.JSlider jSlider2;
  private javax.swing.JSpinner jSpinner1;
  private javax.swing.JSpinner jSpinner2;
  private MainFrame super_frame;

  /**
   * Creates new form MolecularRates
   * @param parent The parent frame, SimpleQuestion
   */
  public MolecularRates(java.awt.Frame parent)
  {
    super(parent, true);
    initComponents();
    super_frame = (MainFrame) parent;
  }

  /** This method is called from within the constructor to
   * initialize the form.
   */
  private void initComponents()
  {
    java.awt.GridBagConstraints gridBagConstraints;

    jSpinner1 = new javax.swing.JSpinner();
    jSpinner2 = new javax.swing.JSpinner();
    jSlider1 = new javax.swing.JSlider();
    jLabel1 = new javax.swing.JLabel();
    jLabel2 = new javax.swing.JLabel();
    jLabel3 = new javax.swing.JLabel();
    jLabel4 = new javax.swing.JLabel();
    jButton1 = new javax.swing.JButton();
    jButton2 = new javax.swing.JButton();
    jSlider2 = new javax.swing.JSlider();

    getContentPane().setLayout(new java.awt.GridBagLayout());

    setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
    jSpinner1.setToolTipText("Transposition rate");
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 1;
    gridBagConstraints.gridy = 0;
    gridBagConstraints.gridwidth = 2;
    gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
    gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
    getContentPane().add(jSpinner1, gridBagConstraints);

    jSpinner2.setToolTipText("Excision rate");
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 1;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.gridwidth = 2;
    gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
    gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
    getContentPane().add(jSpinner2, gridBagConstraints);

    jSlider1.setMajorTickSpacing(25);
    jSlider1.setMaximum(150);
    jSlider1.setMinorTickSpacing(5);
    jSlider1.setPaintLabels(true);
    jSlider1.setPaintTicks(true);
    jSlider1.setToolTipText("Recombination rate between the chromosome tips");
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 1;
    gridBagConstraints.gridy = 3;
    gridBagConstraints.gridwidth = 2;
    gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
    getContentPane().add(jSlider1, gridBagConstraints);

    jLabel1.setText("Transposition rate: ");
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 0;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
    gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
    getContentPane().add(jLabel1, gridBagConstraints);

    jLabel2.setText("Excision rate: ");
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 1;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
    gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
    getContentPane().add(jLabel2, gridBagConstraints);

    jLabel3.setText("Recombination rate: ");
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 3;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
    gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
    getContentPane().add(jLabel3, gridBagConstraints);

    jLabel4.setText("Selection strenght: ");
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 0;
    gridBagConstraints.gridy = 2;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
    gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
    getContentPane().add(jLabel4, gridBagConstraints);

    jButton1.setText("OK");
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 1;
    gridBagConstraints.gridy = 4;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
    gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
    getContentPane().add(jButton1, gridBagConstraints);

    jButton2.setText("Cancel");
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 2;
    gridBagConstraints.gridy = 4;
    gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
    gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
    getContentPane().add(jButton2, gridBagConstraints);

    jSlider2.setMajorTickSpacing(25);
    jSlider2.setMaximum(50);
    jSlider2.setMinorTickSpacing(5);
    jSlider2.setPaintLabels(true);
    jSlider2.setPaintTicks(true);
    jSlider2.setToolTipText("Expected mean copy number");
    gridBagConstraints = new java.awt.GridBagConstraints();
    gridBagConstraints.gridx = 1;
    gridBagConstraints.gridy = 2;
    gridBagConstraints.gridwidth = 2;
    gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
    getContentPane().add(jSlider2, gridBagConstraints);

    // Initialization of value for each component
    Float[] list = new Float[ (int) 1.E5 + 1];
    int list_rang_tx_transpo = 0, list_rang_tx_exci = 0;
    float precision = 1.E-5f;
    for (int i = 0; i <= (int) (1/precision); i++)
    {
      list[i] = new Float( ( (float) i) * precision);
      if (Math.abs(list[i].floatValue()
        - projet_these.et.transElement.getNormTransRate())
        < precision/2)
      {
        list_rang_tx_transpo = i; //the transposition rate rank in list
      }
      if (Math.abs(list[i].floatValue()
        - projet_these.et.transElement.getExciRate())
        < precision/2)
      {
        list_rang_tx_exci = i; //the excision rate rank in list
      }
    }
    javax.swing.SpinnerListModel spinnerListModel1 = new javax.swing.
        SpinnerListModel(list);
    spinnerListModel1.setValue(list[1]);
    jSpinner1.setModel(spinnerListModel1);
    jSpinner1.setValue(list[list_rang_tx_transpo]);
    javax.swing.SpinnerListModel spinnerListModel2 = new javax.swing.
        SpinnerListModel(list);
    jSpinner2.setModel(spinnerListModel2);
    jSpinner2.setValue(list[list_rang_tx_exci]);
    jSlider1.setValue( (int) (100.0f *
                              projet_these.et.ChromosomesPair.getRecRate()));
    float n_star = (projet_these.et.transElement.getNormTransRate() -
                    (projet_these.et.transElement.getExciRate() +
                     projet_these.et.Population.getAlphaValue()));
    n_star = n_star / projet_these.et.Population.getBetaValue();
    jSlider2.setValue( (int) Math.ceil(n_star));

    // Connection of each component with its listener
    jButton1.addActionListener(new OK_AL());
    jButton1.addChangeListener (new SelStrenght_AL());
    jButton2.addActionListener(new Cancel_AL());
    jSpinner1.addChangeListener(new TranspoRate_AL());
    jSpinner2.addChangeListener(new ExciRate_AL());
    jSlider1.addChangeListener(new RecRate_AL());
    jSlider2.addChangeListener(new SelStrenght_AL());
    
    pack();
  }

  /**
   * Implementation of transposition rate spinner listener
   * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
   * @version 07/12/05
   */
  private class TranspoRate_AL
      implements ChangeListener
  {

    /**
     * Procedure setting the transposition rate in the
     * current model
     * @param  e   a change of state of the transposition rate
     *             spinner
     */
    public void stateChanged(ChangeEvent e)
    {
      projet_these.et.transElement.setTransRates(
        ((Float) MolecularRates.this.jSpinner1.getValue()).floatValue());
    }
  }

  /**
   * Implementation of excision rate spinner listener
   * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
   * @version 07/12/05
   */
  private class ExciRate_AL
      implements ChangeListener
  {

    /**
     * Procedure setting the excision rate in the
     * current model
     * @param  e   a change of state of the excision rate
     *             spinner
     */
    public void stateChanged(ChangeEvent e)
    {
      projet_these.et.transElement.setExciRate (
        ((Float) MolecularRates.this.jSpinner2.getValue()).floatValue());
    }
  }

  /**
   * Implementation of selection strenght slider listener
   * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
   * @version 07/12/05
   */
  private class SelStrenght_AL
      implements ChangeListener
  {

    /**
     * Procedure setting the selection coefficients in the
     * current model
     * @param  e   a change of state of the expected mean copy
     *             number slider
     */
    public void stateChanged(ChangeEvent e)
    {
      float coeff_alpha = projet_these.et.Population.DEFAULT_ALPHA;
      float n_star = (int) MolecularRates.this.jSlider2.getValue ();
      if (projet_these.et.transElement.getNormTransRate () >
          projet_these.et.transElement.getExciRate ())
      {
        coeff_alpha = (projet_these.et.transElement.getNormTransRate () -
          projet_these.et.transElement.getExciRate ());
        coeff_alpha = coeff_alpha/(n_star + 1);
        /*Explanation
         *As n_star = u - (v + a)/b at equilibrium for u > v, by assuming
         * that a = b, we then get that a = (u - v)/(n_star + 1)
         */
        projet_these.et.Population.setAlphaValue (coeff_alpha);
        //For the sake of simplicity we assume here that coeff_alpha = coeff_beta
        projet_these.et.Population.setBetaValue (coeff_alpha);
      }
      else
      {
        coeff_alpha = (projet_these.et.transElement.DEFAULT_TRANSPOSITION_RATE -
          projet_these.et.transElement.DEFAULT_EXCISION_RATE);
        coeff_alpha = coeff_alpha/(n_star + 1);
        projet_these.et.Population.setAlphaValue (coeff_alpha);
        projet_these.et.Population.setBetaValue (coeff_alpha);
      }
    }
  }

  /**
   * Implementation of recombination slider listener
   * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
   * @version 07/12/05
   */
  private class RecRate_AL
      implements ChangeListener
  {

    /**
     * Procedure setting the recombination rate in the
     * current model
     * @param  e   a change of state of the recombination
     *             rate slider
     */
    public void stateChanged(ChangeEvent e)
    {
      projet_these.et.ChromosomesPair.setRecRate (
        (new Float(((float) MolecularRates.this.jSlider1.getValue())
        /100f)).floatValue());
    }
  }

  /**
   * Implementation of OK button listener
   * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
   * @version 07/12/05
   */
  private class OK_AL
      implements ActionListener/*, ChangeListener*/
  {

    /**
     * Procedure setting the molecular rates
     * of the current model to there selected value
     * @param  e   a click on the OK button
     */
    public void actionPerformed(ActionEvent e)
    {
      dispose();
    }


//    /**
//     * Procedure setting the excision rate in the
//     * current model
//     * @param  e   a change of state of the excision rate
//     *             spinner
//     */
//    public void stateChanged(ChangeEvent e)
//    {
//
//    }
  }

  /**
   * Implementation of Cancel button listener
   * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
   * @version 07/12/05
   */
  private class Cancel_AL
      implements ActionListener
  {

    /**
     * Procedure setting the molecular rates
     * of the current model to there default value
     * @param  e   a click on the Cancel button
     */
    public void actionPerformed(ActionEvent e)
    {
      projet_these.et.transElement.setTransRates(
          projet_these.et.transElement.DEFAULT_TRANSPOSITION_RATE);
      projet_these.et.transElement.setExciRate(
          projet_these.et.transElement.DEFAULT_EXCISION_RATE);
      projet_these.et.ChromosomesPair.setRecRate(
          projet_these.et.ChromosomesPair.DEFAULT_REC_RATE);
      projet_these.et.Population.setAlphaValue(
          projet_these.et.Population.DEFAULT_ALPHA);
      projet_these.et.Population.setBetaValue(
          projet_these.et.Population.DEFAULT_BETA);
      dispose();
    }
  }
}
