package projet_these.ig;

import projet_these.et.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;




/**
 * Extension of a general internal frame used
 * to ask the population sizes
 * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
 * @version 10/12/02
 */
public class PopulationSizes extends SimpleQuestion
{

    /**
     * The table
     */
    private myTable tablo;
    
    /**
     * Constructor of initialization of PopulationSizes
     * @param super_frame The main frame
     */
    public PopulationSizes(MainFrame super_frame)
    {
        
        // Appel du constructeur de SimpleQuestion
        super(super_frame, "Enter the population sizes :");
        
        // Titre de la fenetre et positionnement
        setTitle("Population Sizes");
        setup();
        
        /* Modification de la question lorsque les tailles ne sont pas
        homogenes*/
        if (getsuperFrame().model.rep_tailles.equals("NH"))
            tablo = setTable();
        
        
        // Sinon une reponse est proposee
        else {
            T1.setText("" + getsuperFrame().model.N[0]);
            T1.setToolTipText("Enter an integer greater than 1");
        }
        
        // Gestion de la fermeture par activation de OK
        B1.addActionListener(new ok_AL());
        
        // Gestion de la fermeture par activation de Return
        B2.addActionListener(new return_AL());
        
    }
    
    
    /**
     * Procedure setting the table of populations sizes
     * @return The table
     */
    private myTable setTable()
    {
        
        // The datas
        Vector datas = new Vector();
        for (int i = 0; i < getsuperFrame().model.nb_pop; i++)
            datas.add(
                    (new Integer(getsuperFrame().model.N[i])).toString());
        for (int i = 0; i < getsuperFrame().model.nb_pop; i++)
            datas.add(i * 2, "Population " + (i + 1) + ":");
        
        // The names
        Vector names = new Vector();
        names.add("Populations");
        names.add("Sizes");
        
        // Le tableau ainsi que les droits d'edition des colonnes
        boolean[] rights = {false, true};
        myTable tablo = new myTable(datas, names, rights);
        
        // Centrage des composants graphiques
        allCentered((JComponent) L1, (JComponent) tablo,
                (JComponent) panel1);
        
        tablo.setToolTipText("Enter an integer greater than 1");
        
        return tablo;
    }
    
    
    /**
     * Procedure returning a reference to the curent
     * internal frame
     * @return the PopulationSizes frame
     */
    private PopulationSizes getPopSizes()
    {
        
        return this;
    }
    
    
    /**
     * Implementation of the ActionListeneter interface
     * to listen to the events of the components
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 01/03/02
     */
    private class ok_AL implements ActionListener
    {
        
        /**
         * Procedure setting the current model populations
         * sizes
         * @param  e   a click on the check box
         */
        public void actionPerformed(ActionEvent e)
        {
            
            /* Si les tailles des populations ne sont pas homogenes
            alors on initialise les tailles des populations*/
            if (getsuperFrame().model.rep_tailles.equals("NH"))
            {
                tablo.uneditingRegularCells();
                for (int i = 0; i < getsuperFrame().model.nb_pop; i++)
                {
                    if (util_IG.errorManager(getPopSizes(),
                            tablo.model.getValueAt(i, 1).toString(),
                            util_IG.POS_INT))
                        return;
                    getsuperFrame().model.N[i] = Integer.valueOf(
                            tablo.model.getValueAt(i, 1).toString()).
                            intValue();
                }
            } // Fin du cas de tailles NH des populations
            
            /* Si les tailles des populations sont homogenes alors
            elles sont toutes mise  la meme valeur*/
            else
            {
                if (util_IG.errorManager(getPopSizes(), T1.getText(),
                        util_IG.POS_INT))
                    return;
                getsuperFrame().model.N[0] =
                        Integer.valueOf(T1.getText()).intValue();
                Arrays.fill(getsuperFrame().model.N,
                        getsuperFrame().model.N[0]);
            } // Fin du cas de tailles H des populations
            
            // On poursuit la procedure d'initialisation
            if (getsuperFrame().entries != null)
                getsuperFrame().entries.upDate();
            CopyNumbers cn = new CopyNumbers(getsuperFrame());
            getsuperFrame().desktop.add(cn);
            try
            {
                cn.setSelected(true);
            }
            catch (java.beans.PropertyVetoException ve)
            {};
            
            // La procedure de saisie des tailles est terminee
            dispose();
            return;
            
        }
    }
    
    
    /**
     * Implementation of the ActionListeneter interface
     * to listen to the events of the components
     * @author Gregory Deceliere - UMR CNRS 5558 - "BBE"
     * @version 01/03/02
     */
    private class return_AL implements ActionListener
    {
        
        
        /**
         * Procedure returning to the OnLine frame
         * @param  e   a click on the Return button
         */
        public void actionPerformed(ActionEvent e)
        {
            
            /* Creation d'une fenetre interne de saisie en ligne
            des parametres*/
            OnLine on_line = new OnLine(getsuperFrame());
            getsuperFrame().desktop.add(on_line);
            try
            {
                on_line.setSelected(true);
            }
            catch (java.beans.PropertyVetoException ve)
            {};
            
            // La procedure de saisie des tailles est reportee
            dispose();
            return;
        }
    }
}



