package projet_these.rn;




/**
 * Implementation of a drawing randomly in [0, 1[
 * @author Numerical Recipes in C
 */
public class Rand1
{


    static final private int IA = 16807;
    static final private long IM = 2147483647L;
    static final private double AM = 1.0 / IM;
    static final private int IQ = 127773;
    static final private int IR = 2836;
    static final private int NTAB = 32;
    static final private long NDIV = 1 + (IM - 1) / NTAB;
    static final private float EPS = 1.2E-7f;
    static final private float RNMX = (float)(1.0 - EPS);
    static private long iy = 0;
    static private long[] iv = new long[NTAB];
    static private long idum = - System.currentTimeMillis();


    /**
     * Random procedure of drawing in [0, 1[
     */
    public static float ran1()
    {

        int j = 0;
        long k = 0;
        float tmp;
        if (idum <= 0 || iy == 0)
        {
            if (- idum < 1)
                idum = 1;
            else
                idum = - idum;
            for (j = NTAB + 7; j >= 0; j--)
            {
                k = (long)(idum / IQ);
                idum = IA * (idum - k * IQ) - IR * k;
                if (idum < 0)
                    idum += IM;
                if (j < NTAB)
                    iv[j] = idum;
            }
            iy = iv[0];
        }
        k = idum / IQ;
        idum = IA * (idum - k * IQ) - IR * k;
        if (idum < 0)
            idum += IM;
        j = (int)(iy / NDIV);
        iy = iv[j];
        iv[j] = idum;
        tmp = (float)(AM * iy);
        if (tmp > RNMX)
            return RNMX;
        else
            return tmp;
    }

}

