package projet_these.rn;




/**
 * Implementation of binomial model
 * @author Numerical Recipes in C
 */
public class bnldev
{


    /**
     * Random procedure of drawing in a ballot box with handing-over
     */
    public static float binom(float pp, int n)
    {

        int j = 0;
        int nold = (-1);
        float am = (float) 0;
        float em = (float) 0;
        float g = (float) 0;
        float angle = (float) 0;
        float p = (float) 0;
        float bnl = (float) 0;
        float sq = (float) 0;
        float t = (float) 0;
        float y = (float) 0;
        float pold = (float)(-1.0);
        float pc = (float) 0;
        float plog = (float) 0;
        float pclog = (float) 0;
        float en = (float) 0;
        float oldg = (float) 0;
        p = (pp <= 0.5 ? pp : 1.0f - pp);
        am = n * p;
        if (n < 25)
        {
            bnl = (float) 0.0;
            for (j = 1; j <= n; j++)
                if (Math.random() < p)
                    ++bnl;
        }
        else if (am < 1.0)
        {
            g = (float) Math.exp(- am);
            t = (float) 1.0;
            for (j = 0; j <= n; j++)
            {
                t *= Math.random();
                if (t < g)
                    break;
            }
            bnl = (j <= n ? j : n);
        }
        else
        {
            if (n != nold)
            {
                en = n;
                oldg = (float) gammln.gammalog(en + 1.0f);
                nold = n;
            }
            if (p != pold)
            {
                pc = 1.0f - p;
                plog = (float) Math.log(p);
                pclog = (float) Math.log(pc);
                pold = p;
            }
            sq = (float) Math.sqrt(2.0 * am * pc);
            do
            {
                do
                {
                    angle = (float)(Math.PI * Math.random());
                    y = (float) Math.tan(angle);
                    em = sq * y + am;
                }
                while (em < 0.0f || em >= (en + 1.0f))
                    ;
                em = (float) Math.floor(em);
                t = 1.2f * sq * (1.0f + y * y) * (float) Math.exp(oldg -
                        gammln.gammalog(em + 1.0f) -
                        gammln.gammalog(en - em + 1.0f) + em * plog +
                        (en - em) * pclog);
            }
            while (Math.random() > t)
                ;
            bnl = em;
        }
        if (p != pp)
            bnl = n - bnl;
        return bnl;
    }

}

