package projet_these.rn;




/**
 * Implementation of a drawing in a Poisson distribution
 * @author Numerical Recipes in C
 */
public class poidev
{


    /**
    * Drawing procedure
    */
    public static float poisson(float xm)
    {

        float sq = 0;
        float alxm = 0;
        float g = 0;
        float oldm = - 1.0f;
        float em = 0;
        float t = 0;
        float y = 0;
        if (xm < 12.0)
        {
            if (xm != oldm)
            {
                oldm = xm;
                g = (float) Math.exp(- xm);
            }
            em = -1;
            t = 1.0f;
            do
            {
                ++em;
                t *= Math.random();
            }
            while (t > g)
                ;
        }
        else
        {
            if (xm != oldm)
            {
                oldm = xm;
                sq = (float) Math.sqrt(2.0 * xm);
                alxm = (float) Math.log(xm);
                g = xm * alxm - gammln.gammalog((float)(xm + 1.0));
            }
            do
            {
                do
                {
                    y = (float) Math.tan(Math.PI * Math.random());
                    em = sq * y + xm;
                }
                while (em < 0.0)
                    ;
                em = (float) Math.floor(em);
                t = (float)(0.9 * (1.0 + y * y) * Math.exp(
                        (double)(em * alxm -
                        gammln.gammalog((float)(em + 1.0)) - g)));
            }
            while (Math.random() > t)
                ;
        }
        return em;
    }

}


